std::tr2::__dynamic_bitset_base< _WordT, _Alloc > Struct Template Reference
Extensions » Dynamic Bitset.

`#include <dynamic_bitset>`

Inheritance diagram for std::tr2::__dynamic_bitset_base< _WordT, _Alloc >:
[legend]

## Public Types

typedef _Alloc | allocator_type
typedef _WordT | block_type
typedef size_t | size_type

## Public Member Functions

| __dynamic_bitset_base (__dynamic_bitset_base &&__b)=default
| __dynamic_bitset_base (const __dynamic_bitset_base &)=default
| __dynamic_bitset_base (const allocator_type &__alloc)
| __dynamic_bitset_base (size_type __nbits, unsigned long long __val=0ULL, const allocator_type &__alloc=allocator_type())
size_t | _M_are_all_aux () const noexcept
void | _M_clear () noexcept
void | _M_do_and (const __dynamic_bitset_base &__x) noexcept
void | _M_do_append_block (block_type __block, size_type __pos)
size_t | _M_do_count () const noexcept
void | _M_do_dif (const __dynamic_bitset_base &__x) noexcept
size_type | _M_do_find_first (size_t __not_found) const
size_type | _M_do_find_next (size_t __prev, size_t __not_found) const
void | _M_do_flip () noexcept
void | _M_do_left_shift (size_t __shift)
void | _M_do_or (const __dynamic_bitset_base &__x) noexcept
void | _M_do_reset () noexcept
void | _M_do_right_shift (size_t __shift)
void | _M_do_set () noexcept
unsigned long long | _M_do_to_ullong () const
unsigned long | _M_do_to_ulong () const
void | _M_do_xor (const __dynamic_bitset_base &__x) noexcept
allocator_type | _M_get_allocator () const noexcept
block_type | _M_getword (size_type __pos) const noexcept
block_type & | _M_getword (size_type __pos) noexcept
block_type | _M_hiword () const noexcept
block_type & | _M_hiword () noexcept
bool | _M_is_any () const noexcept
bool | _M_is_equal (const __dynamic_bitset_base &__x) const noexcept
bool | _M_is_less (const __dynamic_bitset_base &__x) const noexcept
bool | _M_is_proper_subset_of (const __dynamic_bitset_base &__b) const noexcept
bool | _M_is_subset_of (const __dynamic_bitset_base &__b) noexcept
void | _M_resize (size_t __nbits, bool __value)
size_type | _M_size () const noexcept
void | _M_swap (__dynamic_bitset_base &__b) noexcept
__dynamic_bitset_base & | operator= (__dynamic_bitset_base &&)=default
__dynamic_bitset_base & | operator= (const __dynamic_bitset_base &)=default

## Static Public Member Functions

static block_type | _S_maskbit (size_type __pos) noexcept
static size_type | _S_whichbit (size_type __pos) noexcept
static size_type | _S_whichbyte (size_type __pos) noexcept
static size_type | _S_whichword (size_type __pos) noexcept

## Public Attributes

std::vector< block_type, allocator_type > | _M_w

## Static Public Attributes

static const size_type | _S_bits_per_block
static const size_type | npos

## Detailed Description

template<typename _WordT = unsigned long long, typename _Alloc = std::allocator<_WordT>>
struct std::tr2::__dynamic_bitset_base< _WordT, _Alloc >

Base class, general case.

See documentation for dynamic_bitset.

Definition at line 62 of file dynamic_bitset.

## Member Typedef Documentation

## allocator_type

template<typename _WordT = unsigned long long, typename _Alloc = std::allocator<_WordT>>

typedef _Alloc std::tr2::__dynamic_bitset_base< _WordT, _Alloc >::allocator_type

Definition at line 68 of file dynamic_bitset.

## block_type

template<typename _WordT = unsigned long long, typename _Alloc = std::allocator<_WordT>>

typedef _WordT std::tr2::__dynamic_bitset_base< _WordT, _Alloc >::block_type

Definition at line 67 of file dynamic_bitset.

## size_type

template<typename _WordT = unsigned long long, typename _Alloc = std::allocator<_WordT>>

typedef size_t std::tr2::__dynamic_bitset_base< _WordT, _Alloc >::size_type

Definition at line 69 of file dynamic_bitset.

## Constructor & Destructor Documentation

## __dynamic_bitset_base() [1/2]

template<typename _WordT = unsigned long long, typename _Alloc = std::allocator<_WordT>>

std::tr2::__dynamic_bitset_base< _WordT, _Alloc >::__dynamic_bitset_base | ( | const allocator_type & | __alloc | ) |

inline explicit

Definition at line 78 of file dynamic_bitset.

## __dynamic_bitset_base() [2/2]

template<typename _WordT = unsigned long long, typename _Alloc = std::allocator<_WordT>>

std::tr2::__dynamic_bitset_base< _WordT, _Alloc >::__dynamic_bitset_base | ( | size_type | __nbits,
|  | unsigned long long | __val = `0ULL`,
|  | const allocator_type & | __alloc = `allocator_type()`
| ) |  |

inline explicit

Definition at line 90 of file dynamic_bitset.

## Member Function Documentation

## _M_are_all_aux()

template<typename _WordT = unsigned long long, typename _Alloc = std::allocator<_WordT>>

size_t std::tr2::__dynamic_bitset_base< _WordT, _Alloc >::_M_are_all_aux | ( |  | ) | const

inline noexcept

Definition at line 272 of file dynamic_bitset.

## _M_clear()

template<typename _WordT = unsigned long long, typename _Alloc = std::allocator<_WordT>>

void std::tr2::__dynamic_bitset_base< _WordT, _Alloc >::_M_clear | ( |  | ) |

inline noexcept

Definition at line 119 of file dynamic_bitset.

## _M_do_and()

template<typename _WordT = unsigned long long, typename _Alloc = std::allocator<_WordT>>

void std::tr2::__dynamic_bitset_base< _WordT, _Alloc >::_M_do_and | ( | const __dynamic_bitset_base< _WordT, _Alloc > & | __x | ) |

inline noexcept

Definition at line 174 of file dynamic_bitset.

## _M_do_append_block()

template<typename _WordT = unsigned long long, typename _Alloc = std::allocator<_WordT>>

void std::tr2::__dynamic_bitset_base< _WordT, _Alloc >::_M_do_append_block | ( | block_type | __block,
|  | size_type | __pos
| ) |  |

inline

Definition at line 347 of file dynamic_bitset.

## _M_do_count()

template<typename _WordT = unsigned long long, typename _Alloc = std::allocator<_WordT>>

size_t std::tr2::__dynamic_bitset_base< _WordT, _Alloc >::_M_do_count | ( |  | ) | const

inline noexcept

Definition at line 319 of file dynamic_bitset.

## _M_do_dif()

template<typename _WordT = unsigned long long, typename _Alloc = std::allocator<_WordT>>

void std::tr2::__dynamic_bitset_base< _WordT, _Alloc >::_M_do_dif | ( | const __dynamic_bitset_base< _WordT, _Alloc > & | __x | ) |

inline noexcept

Definition at line 204 of file dynamic_bitset.

## _M_do_find_first()

template<typename _WordT , typename _Alloc >

size_t std::tr2::__dynamic_bitset_base< _WordT, _Alloc >::_M_do_find_first | ( | size_t | __not_found | ) | const

Definition at line 125 of file dynamic_bitset.tcc.

## _M_do_find_next()

template<typename _WordT , typename _Alloc >

size_t std::tr2::__dynamic_bitset_base< _WordT, _Alloc >::_M_do_find_next | ( | size_t | __prev,
|  | size_t | __not_found
| ) |  | const

Definition at line 141 of file dynamic_bitset.tcc.

## _M_do_flip()

template<typename _WordT = unsigned long long, typename _Alloc = std::allocator<_WordT>>

void std::tr2::__dynamic_bitset_base< _WordT, _Alloc >::_M_do_flip | ( |  | ) |

inline noexcept

Definition at line 220 of file dynamic_bitset.

## _M_do_left_shift()

template<typename _WordT , typename _Alloc >

void std::tr2::__dynamic_bitset_base< _WordT, _Alloc >::_M_do_left_shift | ( | size_t | __shift | ) |

Definition at line 44 of file dynamic_bitset.tcc.

## _M_do_or()

template<typename _WordT = unsigned long long, typename _Alloc = std::allocator<_WordT>>

void std::tr2::__dynamic_bitset_base< _WordT, _Alloc >::_M_do_or | ( | const __dynamic_bitset_base< _WordT, _Alloc > & | __x | ) |

inline noexcept

Definition at line 184 of file dynamic_bitset.

## _M_do_reset()

template<typename _WordT = unsigned long long, typename _Alloc = std::allocator<_WordT>>

void std::tr2::__dynamic_bitset_base< _WordT, _Alloc >::_M_do_reset | ( |  | ) |

inline noexcept

Definition at line 234 of file dynamic_bitset.

## _M_do_right_shift()

template<typename _WordT , typename _Alloc >

void std::tr2::__dynamic_bitset_base< _WordT, _Alloc >::_M_do_right_shift | ( | size_t | __shift | ) |

Definition at line 69 of file dynamic_bitset.tcc.

## _M_do_set()

template<typename _WordT = unsigned long long, typename _Alloc = std::allocator<_WordT>>

void std::tr2::__dynamic_bitset_base< _WordT, _Alloc >::_M_do_set | ( |  | ) |

inline noexcept

Definition at line 227 of file dynamic_bitset.

## _M_do_to_ullong()

template<typename _WordT , typename _Alloc >

unsigned long long std::tr2::__dynamic_bitset_base< _WordT, _Alloc >::_M_do_to_ullong | ( |  | ) | const

Definition at line 110 of file dynamic_bitset.tcc.

## _M_do_to_ulong()

template<typename _WordT , typename _Alloc >

unsigned long std::tr2::__dynamic_bitset_base< _WordT, _Alloc >::_M_do_to_ulong | ( |  | ) | const

Definition at line 96 of file dynamic_bitset.tcc.

## _M_do_xor()

template<typename _WordT = unsigned long long, typename _Alloc = std::allocator<_WordT>>

void std::tr2::__dynamic_bitset_base< _WordT, _Alloc >::_M_do_xor | ( | const __dynamic_bitset_base< _WordT, _Alloc > & | __x | ) |

inline noexcept

Definition at line 194 of file dynamic_bitset.

## _M_get_allocator()

template<typename _WordT = unsigned long long, typename _Alloc = std::allocator<_WordT>>

allocator_type std::tr2::__dynamic_bitset_base< _WordT, _Alloc >::_M_get_allocator | ( |  | ) | const

inline noexcept

Definition at line 138 of file dynamic_bitset.

## _M_getword() [1/2]

template<typename _WordT = unsigned long long, typename _Alloc = std::allocator<_WordT>>

block_type std::tr2::__dynamic_bitset_base< _WordT, _Alloc >::_M_getword | ( | size_type | __pos | ) | const

inline noexcept

Definition at line 162 of file dynamic_bitset.

## _M_getword() [2/2]

template<typename _WordT = unsigned long long, typename _Alloc = std::allocator<_WordT>>

block_type & std::tr2::__dynamic_bitset_base< _WordT, _Alloc >::_M_getword | ( | size_type | __pos | ) |

inline noexcept

Definition at line 158 of file dynamic_bitset.

## _M_hiword() [1/2]

template<typename _WordT = unsigned long long, typename _Alloc = std::allocator<_WordT>>

block_type std::tr2::__dynamic_bitset_base< _WordT, _Alloc >::_M_hiword | ( |  | ) | const

inline noexcept

Definition at line 170 of file dynamic_bitset.

## _M_hiword() [2/2]

template<typename _WordT = unsigned long long, typename _Alloc = std::allocator<_WordT>>

block_type & std::tr2::__dynamic_bitset_base< _WordT, _Alloc >::_M_hiword | ( |  | ) |

inline noexcept

Definition at line 166 of file dynamic_bitset.

## _M_is_any()

template<typename _WordT = unsigned long long, typename _Alloc = std::allocator<_WordT>>

bool std::tr2::__dynamic_bitset_base< _WordT, _Alloc >::_M_is_any | ( |  | ) | const

inline noexcept

Definition at line 282 of file dynamic_bitset.

## _M_is_equal()

template<typename _WordT = unsigned long long, typename _Alloc = std::allocator<_WordT>>

bool std::tr2::__dynamic_bitset_base< _WordT, _Alloc >::_M_is_equal | ( | const __dynamic_bitset_base< _WordT, _Alloc > & | __x | ) | const

inline noexcept

Definition at line 240 of file dynamic_bitset.

## _M_is_less()

template<typename _WordT = unsigned long long, typename _Alloc = std::allocator<_WordT>>

bool std::tr2::__dynamic_bitset_base< _WordT, _Alloc >::_M_is_less | ( | const __dynamic_bitset_base< _WordT, _Alloc > & | __x | ) | const

inline noexcept

Definition at line 254 of file dynamic_bitset.

## _M_is_proper_subset_of()

template<typename _WordT = unsigned long long, typename _Alloc = std::allocator<_WordT>>

bool std::tr2::__dynamic_bitset_base< _WordT, _Alloc >::_M_is_proper_subset_of | ( | const __dynamic_bitset_base< _WordT, _Alloc > & | __b | ) | const

inline noexcept

Definition at line 305 of file dynamic_bitset.

## _M_is_subset_of()

template<typename _WordT = unsigned long long, typename _Alloc = std::allocator<_WordT>>

bool std::tr2::__dynamic_bitset_base< _WordT, _Alloc >::_M_is_subset_of | ( | const __dynamic_bitset_base< _WordT, _Alloc > & | __b | ) |

inline noexcept

Definition at line 291 of file dynamic_bitset.

## _M_resize()

template<typename _WordT = unsigned long long, typename _Alloc = std::allocator<_WordT>>

void std::tr2::__dynamic_bitset_base< _WordT, _Alloc >::_M_resize | ( | size_t | __nbits,
|  | bool | __value
| ) |  |

inline

Definition at line 123 of file dynamic_bitset.

## _M_size()

template<typename _WordT = unsigned long long, typename _Alloc = std::allocator<_WordT>>

size_type std::tr2::__dynamic_bitset_base< _WordT, _Alloc >::_M_size | ( |  | ) | const

inline noexcept

Definition at line 328 of file dynamic_bitset.

## _M_swap()

template<typename _WordT = unsigned long long, typename _Alloc = std::allocator<_WordT>>

void std::tr2::__dynamic_bitset_base< _WordT, _Alloc >::_M_swap | ( | __dynamic_bitset_base< _WordT, _Alloc > & | __b | ) |

inline noexcept

Definition at line 115 of file dynamic_bitset.

## _S_maskbit()

template<typename _WordT = unsigned long long, typename _Alloc = std::allocator<_WordT>>

static block_type std::tr2::__dynamic_bitset_base< _WordT, _Alloc >::_S_maskbit | ( | size_type | __pos | ) |

inline static noexcept

Definition at line 154 of file dynamic_bitset.

## _S_whichbit()

template<typename _WordT = unsigned long long, typename _Alloc = std::allocator<_WordT>>

static size_type std::tr2::__dynamic_bitset_base< _WordT, _Alloc >::_S_whichbit | ( | size_type | __pos | ) |

inline static noexcept

Definition at line 150 of file dynamic_bitset.

## _S_whichbyte()

template<typename _WordT = unsigned long long, typename _Alloc = std::allocator<_WordT>>

static size_type std::tr2::__dynamic_bitset_base< _WordT, _Alloc >::_S_whichbyte | ( | size_type | __pos | ) |

inline static noexcept

Definition at line 146 of file dynamic_bitset.

## _S_whichword()

template<typename _WordT = unsigned long long, typename _Alloc = std::allocator<_WordT>>

static size_type std::tr2::__dynamic_bitset_base< _WordT, _Alloc >::_S_whichword | ( | size_type | __pos | ) |

inline static noexcept

Definition at line 142 of file dynamic_bitset.

## Member Data Documentation

## _M_w

template<typename _WordT = unsigned long long, typename _Alloc = std::allocator<_WordT>>

std::vector<block_type, allocator_type> std::tr2::__dynamic_bitset_base< _WordT, _Alloc >::_M_w

0 is the least significant word.

Definition at line 75 of file dynamic_bitset.

## _S_bits_per_block

template<typename _WordT = unsigned long long, typename _Alloc = std::allocator<_WordT>>

const size_type std::tr2::__dynamic_bitset_base< _WordT, _Alloc >::_S_bits_per_block

static

Definition at line 71 of file dynamic_bitset.

## npos

template<typename _WordT = unsigned long long, typename _Alloc = std::allocator<_WordT>>

const size_type std::tr2::__dynamic_bitset_base< _WordT, _Alloc >::npos

static

Definition at line 72 of file dynamic_bitset.

The documentation for this struct was generated from the following files:

- dynamic_bitset
- dynamic_bitset.tcc